
#include <Ice/Ice.h>

// As generated by slice

class A;
typedef ::IceInternal::Handle<A> APtr;

class A : virtual public ::Ice::Object
{
public:
  // TODO: explicit initialization of member 'mFlags'
  A() {}
  //A() : mFlags(0LL) {}
  virtual ~A() {}
  virtual void dispose(const ::Ice::Current& = ::Ice::Current()) = 0;
  ::Ice::Long   mFlags;
};

// Implementation

class AImpl : virtual public A
{
public:
  AImpl() : A() {}
  virtual ~AImpl() {}

  virtual void dispose(const ::Ice::Current& curr) {
	::Ice::Long mask = 1LL;
    if((mFlags & mask)  != 0) {
        throw ::Ice::ObjectNotExistException(__FILE__, __LINE__);
    }
	mFlags |= mask;
  }
};

// Test class

using namespace std;

class InitTest
{
 public:
  InitTest() {}
  virtual ~InitTest() {}
  void test1() {
	APtr ptr1(new AImpl());
	cout << endl << "ptr1: " << ptr1.get() << endl;
	ptr1->dispose();
	ptr1 = 0;
  }
  void test2() {
	APtr ptr2(new AImpl());
	cout << endl << "ptr2: " << ptr2.get() << endl;
	ptr2->dispose();
	ptr2 = 0;
  }
};

// Main

int 
main( int argc, char* argv[] )
{
  int status = 0;
  {
	InitTest t1;
	t1.test1();
  }
  try {
	InitTest t2;
	t2.test2();
  } catch (::Ice::ObjectNotExistException& e) {
	cout << e.ice_name() << endl;
	status = 1;
  }
  return status;
}
